#  bgl-asm.awk
#
#  use:    awk95 -f bgl-asm.awk *.asm 
#
#  input:  bgl-asm.txt - a list of the areas to flatten
#          *.asm       - the asm file to "edit", created by BGLAnalyze
#
#  output: bgl-asm.asm - compile with BGLC to create the new blg file
#
#  help:   support@fs-traveler.com
#
#  ===========================================================

BEGIN{
  outfile="bgl-asm.asm"
  level=1
  while (getline <"bgl-asm.txt" >0){
    if( length($0)>0 && substr($1,1,1)!="#" && substr($1,1,1)!="="  ){
      cells["Cell_" $1 "_" $2] =1 
      cellsareas["Cell_" $1 "_" $2"-" rc] = $3 ":" $4 ":" $5 ":"$6
      rc++  
    } 
  } 
  bglfile=substr(ARGV[1],1,index(ARGV[1],".")-1)
  for (i in cells) cellctr++
  system("date < date-cr.dat  > date.txt" )
  getline  < "date.txt"
  close("date.txt")
  system("del date.txt")
  print ";;  bgl-asm.asm, constructed from " bglfile ".asm by bgl-asm.awk on " $4 " " $5  >outfile
  print ";;  bgl-asm.awk 2003 Flight Sim Traveler\n\n" >outfile
}
#===========================================================

NR%1000==0{print NR " lines processed"}

/^[#=]/{next}

/^LWMIndexHeader/{
  $2 = cellctr  ", "
  print > outfile
  next
}

/^LWMIndexData/{
  level=2
  print > outfile
  next
}

/^LWMDataStart/{
  level=3
  print "\n" $0 "\n"> outfile
  next
}

/^LWMEnd/{print  > outfile}

level ~5 { 
  if (match($0,"LWMPoint") >0 )print > outfile
  else if (match($0,"LWMPoly")>0 ){
    $5=elevM","   
    $6=elevMm
    print > outfile
  }
  else level=4
}

level ~ 4 {
  if (match($1,"LWMDataAreaDrawPolygon") >0){
    asmAreaX=  $5+0
    asmAreaY=  $6+0

    if(parseDataArea()){
      print > outfile
      getline
      $5=elevM","   
      $6=elevMm
      print > outfile
      level=5
    }
  }
  else if (match($1,"LWMDataAreaFill1x1") >0){
    asmAreaX=  $5+0
    asmAreaY=  $6+0
    AreaFillSize=$1

    if(parseAreaFill()){
      print > outfile
      getline
      $2=elevM","   
      $3=elevMm
      print > outfile
    }
  }
  else if (match($1,"LWMDataAreaFill") >0){
    asmAreaX=  $6+0
    asmAreaY=  $8+0
    AreaFillSize=$1

    if(parseAreaFill()){
      print > outfile
      getline
      $2=elevM","   
      $3=elevMm
      print  > outfile
    }
  }
  else if (($1 in enddata)){
    level=3
    print $0 "\n" > outfile
  }
}

level ~ 3 {
  if (($1 in begindata)){ 
    level=4
    currentCell=begindata[$1]
    print > outfile
  }
}

level ~ 2 {
  if ($1 in cells){
    print > outfile
    t_cell=$1
    getline
    print $0 > outfile
    begincell[t_cell]=1
    begindata[substr($4,1,length($4)-1)]=t_cell
    enddata[$5]=1 
  }
}
level ~ 1 {print > outfile}
#===========================================================

function parseDataArea(){
  for (i in cellsareas){
    if ( currentCell == substr(i,1,match(i,"-")-1)){
      split(cellsareas[i],reqCoords,":")
      reqAreaX=reqCoords[1]
      reqAreaY=reqCoords[2]
      elevM=reqCoords[3]
      elevMm=reqCoords[4]
      if (asmAreaX==reqAreaX && asmAreaY==reqAreaY) return 1
    } 
 }
  return 0
}

function parseAreaFill(){
  for (i in cellsareas){
    if ( currentCell == substr(i,1,match(i,"-")-1)){
      split(cellsareas[i],reqCoords,":")
      reqAreaX=reqCoords[1]
      reqAreaY=reqCoords[2]
      elevM=reqCoords[3]
      elevMm=reqCoords[4]
      if (AreaFillSize=="LWMDataAreaFill1x1" &&  asmAreaX==int(reqAreaX/1) &&  asmAreaY==int(reqAreaY/1)) return 1
      if (AreaFillSize=="LWMDataAreaFill2x2" &&  asmAreaX==int(reqAreaX/2) &&  asmAreaY==int(reqAreaY/2)) return 1
      if (AreaFillSize=="LWMDataAreaFill4x4" &&  asmAreaX==int(reqAreaX/4) &&  asmAreaY==int(reqAreaY/4)) return 1
      if (AreaFillSize=="LWMDataAreaFill8x8" &&  asmAreaX==int(reqAreaX/8) &&  asmAreaY==int(reqAreaY/8)) return 1
      if (AreaFillSize=="LWMDataAreaFill16x16" &&  asmAreaX==int(reqAreaX/16) &&  asmAreaY==int(reqAreaY/16)) return 1
    } 
 }
  return 0
}
#===========================================================

END{ 
  z=system("copy bgl-asm.txt " bglfile ".txt")
  if(z == 0) print"\nBackup copy of bgl-asm.txt saved as " bglfile ".txt"
  print NR " lines processed in "ARGV[1]
 }

